package jpg2ascii;

import java.io.*;
import java.util.*;

public class AsciiGenerator{
	private String fileName, mapFileName;
	private String[] myChar;
	private BufferedWriter asciiFile;
	private int z,x,i;

	public AsciiGenerator(String f, String mf){
		this.fileName = f;
		this.mapFileName = mf;

		fileName = fileName.substring(0, (fileName.length() - 3)) + "txt";
		try{
			readMapFile(mapFileName);
			asciiFile = new BufferedWriter(new FileWriter(fileName));
		} catch(Exception err){
			err.printStackTrace();
			System.exit(0);
		}
	}

	public void newLine(){
		try{
			asciiFile.write("\n");
		} catch (Exception err){
			err.printStackTrace();
		}
	}

	public void createPixel(int[] col){
		// col[0] is color red
		i = myChar.length;
		x = 255/i;
		z = i;
		try{
			while(z > 0){
				if(col[0] <= (z-1)*x && z>1){
					z--;
				}
				else {
					asciiFile.write(myChar[z-1]);
					break;
				}

			}
		} catch (Exception err){
			err.printStackTrace();
		}
	}

	public void closeFile(){
		try{
			asciiFile.flush();
			asciiFile.close();
		} catch (Exception err){
			err.printStackTrace();
		}
	}

	public void readMapFile(String mapFile){
		Properties chars = new Properties();
		try{
			chars.load(new FileInputStream(new File(mapFile)));
		} catch (Exception err){
			err.printStackTrace();
		}
		int i=0;
		String a = "";
		// check howmany steps we need for graphics
		// a.valueOf() is a stupid typecast
		while(true){
			if(chars.getProperty(a.valueOf(i), null) == null) break;
			i++;
		}
		System.out.println("there are "+i+" grey steps");
		myChar = new String[i--];
		// read props into the array
		for(; i>=0; i--){
			a = a.valueOf(i);
			myChar[i]= chars.getProperty(a," ") ;
		}
	}

}
